'=============================================================================
'
'       CRF-1xx V[Y̐Tv\tg
'       [ CRF_SampleSoft Version 1.1 ]
'
'       ʐMɕKvȋʂ̊֐AϐA萔̃W[ [modFunction.vb]
'
'       J
'           EMicrosoft Visual Basic 2008
'           E.NET Framework version 2.5
'
'       ӎ
'           EʐM͊ei̕WݒiLĵݑΉ
'             9600bpsA8bitAEvenParityA1StopBitABCC 1oCg
'             wb_[FSTX(02h)Atb^[FETX(03h)AZp[^FUS(1Fh)
'
'       GRAPHTEC Corporation      2008/06/03
'
'=============================================================================
'
'       ύX
'       Ver1.0.0.0      2008/11/18     o[W
'       Ver1.1.0.0      2017/10/24     1)ЖύX
'                                      2)AnalyzeReadData()֐JIS2f[^͏̒
'
'=============================================================================
Module modFunction

    '-------------------------------------------------------------------------------------
    '   O[p萔錾
    '-------------------------------------------------------------------------------------
    Public Const ACK = Chr(&H6)                      'R[h ACK
    Public Const NAK = Chr(&H15)                     'R[h NAK 
    Public Const DLE = Chr(&H10)                     'R[h DLE 
    Public Const STX = Chr(&H2)                      'R[h STX 
    Public Const ETX = Chr(&H3)                      'R[h ETX
    Public Const US = Chr(&H1F)                      'R[h US
    Public Const SO = Chr(&HE)                       'R[h SO
    Public Const SI = Chr(&HF)                       'R[h SI
    Public Const CR = Chr(&HD)                       'R[h CR
    Public Const LF = Chr(&HA)                       'R[h LF

    Public Const NO_FINISH_RES = -1                  'M̏ԃtO
    Public Const COMMAND_RES = 0                     'R}h̏ԃtO
    Public Const EVENT_RES = 1                       'Cxg̏ԃtO
    Public Const BCC_ERROR = 3                       'BCCG[̏ԃtO

    '-------------------------------------------------------------------------------------
    '   O[pϐ錾
    '-------------------------------------------------------------------------------------
    Public JIS2Model As Boolean                      'JIS2^Cv̋@̃tOϐ
    Public ReceiveBuff As String                     'Mobt@iꎞIȃf[^ϐj
    Public ReceiveData As String                     'Mf[^
    Public Header As String                          'Mf[^̃wb_
    Public Parameter As String                       'Mf[^̃p[^
    Public ReadData(2) As String                     'gbÑ[hf[^
    Public ReadWriteResult(2) As String              'gbÑ[hECg

    '-------------------------------------------------------------------------------------
    '   Tv@FR}hSTX,ETX,BCCǉ֐
    '   @FSource ̃R}h
    '   ߂lFǉ̕
    '-------------------------------------------------------------------------------------
    Public Function AddStxEtxBcc(ByVal Source As String) As String
        Dim D As String
        Dim i As Integer
        Dim BCC As Byte
        D = Chr(&H2)
        BCC = 0
        For i = 0 To Source.Length - 1
            BCC = BCC Xor Asc(Source.Chars(i))
        Next
        BCC = BCC Xor &H3
        D = D & Source & Chr(&H3) & Chr(BCC)
        Return D
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@FMԂmFĎM𔻒肷֐
    '   @FSource M
    '   ߂lFM̔茋
    '                -1:NO_FINISH_RES (M)
    '                 0:COMMAND_RES   (R}hM)
    '                 1:EVENT_RES     (CxgM)
    '                 3:BCC_ERROR     (MBCCG[)
    '-------------------------------------------------------------------------------------
    Public Function CheckReceiveData(ByVal Source As String) As Integer
        Dim i As Integer
        Dim blnSTX, blnETX, blnBCC, blnFinish As Boolean
        Dim BCC As Byte

        blnFinish = False
        If Len(Source) = 1 Then                         'R[h̊mF
            Select Case Source
                Case ACK, NAK, DLE
                    ReceiveData = Source
                    Header = Source
                    Parameter = ""
                    Return COMMAND_RES                  'R}hM
            End Select
        Else                                            '̑̉̊mF
            blnSTX = False                              'STXMtONA
            blnETX = False                              'ETXMtONA
            blnBCC = False                              'BCCMtONA
            BCC = 0
            For i = 0 To Len(Source) - 1                'STX,ETX,BCC̊mF
                If blnETX Then
                    blnFinish = True
                    If BCC = Asc(Source(i)) Then
                        blnBCC = True
                    Else
                        blnBCC = False
                    End If
                End If
                If blnFinish Then Exit For
                If blnSTX And (Not blnETX) Then BCC = BCC Xor Asc(Source(i)) 'BCČvZ
                If (Not blnETX) And (Source(i) = STX) Then blnSTX = True
                If blnSTX And (Source(i) = ETX) Then blnETX = True
            Next
        End If

        If blnFinish Then                               'M̏ꍇ
            ReceiveData = Source                        'Mf[^ϐɊi[
            Header = Mid(Source, 2, 2)                  'wb_[̒o
            Parameter = Mid(Source, 4, Len(Source) - 5) 'p[^̒o
            If blnBCC Then
                Select Case Mid(Source, 2, 2)
                    Case "CR", "CW"
                        Return EVENT_RES                'Cxg̎M
                    Case "AE", "DH"
                        Return EVENT_RES                'Cxg̎M
                    Case Else
                        Return COMMAND_RES              'R}h̎M
                End Select
            Else
                Return BCC_ERROR                        'MBCCG[
            End If
        Else
            Return NO_FINISH_RES                        'M
        End If
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@FXe[^X̃p[^Xe[^X擾֐
    '   @FstrParam PS̃p[^
    '   ߂lFXe[^X񕶎
    '-------------------------------------------------------------------------------------
    Public Function GetStatus_Information(ByVal strParam As String) As String
        Dim strMsg As String

        strMsg = "ԁF"
        Select Case Mid(strParam, 2, 2)                           'Ԃ̃Xe[^X
            Case "00"
                strMsg = strMsg + "֎~"
            Case "01"
                strMsg = strMsg + "CJ[hǂݎ҂"
            Case "02"
                strMsg = strMsg + "CJ[hݑ҂"
            Case "03"
                strMsg = strMsg + "J[hĎ"
        End Select

        strMsg = strMsg + " / ZT[F" + Mid(strParam, 4, 1)   'ZT[̃Xe[^X

        strMsg = strMsg + " / VXe\F" + Mid(strParam, 5, 4)

        Return strMsg
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@FNG̃p[^G[bZ[W擾֐
    '   @FstrParam NG̃p[^
    '   ߂lFG[bZ[W
    '-------------------------------------------------------------------------------------
    Public Function GetNG_Information(ByVal strParam As String) As String
        Dim strMsg As String = ""
        Select Case strParam
            Case "001"
                strMsg = "R}hG["
            Case "002"
                strMsg = "p[^G["
            Case "006"
                strMsg = "uɃJ[h܂"
        End Select
        Return strMsg
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@FDHCxgiG[Cxgj̃p[^G[bZ[W擾֐
    '   @FstrParam DHCxg̃p[^
    '   ߂lFG[bZ[W
    '-------------------------------------------------------------------------------------
    Public Function GetDH_Information(ByVal strParam As String) As String
        Dim strMsg As String = ""
        Select Case strParam
            Case "03"
                strMsg = "J[hُł"
            Case "06"
                strMsg = "^CAEgł"
        End Select
        Return strMsg
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@Fǂݎ^݌ʃR[hG[bZ[W擾֐
    '   @FstrNo ǂݎ^݌ʃR[h
    '   ߂lFG[bZ[W
    '-------------------------------------------------------------------------------------
    Public Function GetErrorInformation(ByVal strNo As String) As String
        Dim strMsg As String = ""
        Select Case strNo
            Case "0"
                strMsg = "I"                   'ُȂ
            Case "1"
                strMsg = "STXG["                  'STXȂ
            Case "2"
                strMsg = "ETXG["                  'ETXȂ
            Case "3"
                strMsg = "peBG["         'peBȂ
            Case "4"
                strMsg = "LRCG["                  'LRCȂ
            Case "5"
                strMsg = "f[^tH[}bgG["   'J[htH[}bgȂ
            Case "7"
                strMsg = "݃f[^G["       'Cgf[^ƃ[hf[^Ȃ
        End Select
        Return strMsg
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@F[hf[^ɃJiꍇSO/SIR[hǉShiftINɕϊ֐
    '   @FstrSource@ ̃f[^
    '   ߂lFϊ̃f[^
    '-------------------------------------------------------------------------------------
    Public Function CheckKANA(ByVal strSource As String) As String
        Dim strTemp As String = strSource
        Dim strResult As String = ""                   'ϊ̕
        Dim i As Integer
        Dim CN As Integer
        Dim blnShifOut As Boolean = False               'ShiftOut^IÑtO

        For i = 1 To Len(strTemp)                       '擪Ō܂ŊmF
            CN = Asc(Mid(strTemp, i, 1))
            If CN >= &H80 Then                          'ASCIIR[h80hȏ̏ꍇ
                If Not blnShifOut Then
                    strResult = strResult & SO          'ShiftOutĂȂꍇSO(0Eh)̒ǉ
                    blnShifOut = True
                End If
                CN = CN - &H80                          'ShiftIN̕ɕϊ
            Else
                If blnShifOut Then
                    strResult = strResult & SI          'ShiftINĂȂꍇSI(0Fh)̒ǉ
                    blnShifOut = False
                End If
            End If
            strResult = strResult & Chr(CN)
        Next i
        If blnShifOut Then strResult = strResult & SI 'ShiftINĂȂꍇSI(0Fh)̒ǉ
        Return strResult
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@F[hf[^SO/SIR[hꍇ̓Jiɕϊ֐
    '   @FstrSource@ ̃f[^
    '   ߂lFϊ̃f[^
    '-------------------------------------------------------------------------------------
    Public Function CheckSOSI(ByVal strSource As String) As String
        Dim strTemp As String
        Dim strResult As String                         'ϊ̕
        Dim blnShifOut As Boolean                       'ShiftOut^IÑtO
        Dim i As Integer
        Dim CN As Integer

        strTemp = strSource
        strResult = ""
        blnShifOut = False

        For i = 1 To Len(strTemp)                       '擪Ō܂ŊmF
            CN = Asc(Mid(strTemp, i, 1))
            Select Case CN
                Case &HE                                'ShiftOut̂Ƃ
                    blnShifOut = True
                Case &HF                                'ShiftIN̂Ƃ
                    blnShifOut = False
                Case Else
                    If blnShifOut Then CN = CN + &H80 'ASCIIR[h80hȏɕϊ
            End Select
            strResult = strResult & Chr(CN)
        Next i
        Return strResult
    End Function

    '-------------------------------------------------------------------------------------
    '   Tv@F[hf[^gbÑJ[hf[^ƃ[hʂ𒊏oăO[oϐɊi[܂B
    '   @FstrSource@ ̃f[^
    '   ߂lFȂ
    '-------------------------------------------------------------------------------------
    Public Sub AnalyzeReadData(ByVal strData As String)
        Dim i, t As Integer
        Dim Work As String = strData
        If Work = "" Then Exit Sub
        For i = 0 To 2
            ReadData(i) = ""
            ReadWriteResult(i) = ""
        Next
        If Work(0) = "C" Then Work = Mid(Work, 2) 'p[^mF

        If JIS2Model Then                           'JIS2^Cv̂Ƃ
            ReadWriteResult(0) = Left(Work, 1)
            If ReadWriteResult(0) = "0" Then ReadData(0) = Mid(Work, 2)
        Else                                        'ISO^Cv̂Ƃ
            t = 0                                   'Zp[^mFȂegbÑf[^𒊏o
            For i = 0 To Len(Work) - 1
                If Work(i) = US Then
                    t += 1
                Else
                    Select Case ReadWriteResult(t)
                        Case ""
                            ReadWriteResult(t) = Work(i)
                        Case "0"
                            ReadData(t) = ReadData(t) & Work(i)
                    End Select
                End If
            Next
        End If
    End Sub

    '-------------------------------------------------------------------------------------
    '   Tv@FCgf[^gbÑCgʂ𒊏oăO[oϐɊi[܂B
    '   @FstrSource@ ̃f[^
    '   ߂lFȂ
    '-------------------------------------------------------------------------------------
    Public Sub AnalyzeWriteResult(ByVal strData As String)
        Dim i, t As Integer
        Dim Work As String = strData
        If Work = "" Then Exit Sub
        For i = 0 To 2
            ReadWriteResult(i) = ""
        Next
        If Work(0) = "C" Then Work = Mid(Work, 2) 'p[^mF

        If JIS2Model Then                           'JIS2^Cv̂Ƃ
            ReadWriteResult(0) = Left(Work, 1)
        Else                                        'ISO^Cv̂Ƃ
            t = 0                                   'Zp[^mFȂegbŇʂ𒊏o
            For i = 0 To Len(Work) - 1
                If Work(i) = US Then
                    t += 1
                Else
                    If ReadWriteResult(t) = "" Then ReadWriteResult(t) = Work(i)
                End If
            Next
        End If
    End Sub

    '-------------------------------------------------------------------------------------
    '   Tv@Fɕ\łȂR[hꍇ͎w肵ɒu֐
    '   @FstrSource@ ̕
    '           strNew      u镶
    '   ߂lFϊ̕
    '-------------------------------------------------------------------------------------
    Public Function CheckControlCode(ByVal strSource As String, ByVal strNew As String) As String
        Dim strResult As String = ""                                             'ϊ̕
        Dim i As Integer
        Dim CN As Integer
        For i = 0 To Len(strSource) - 1                                          '擪Ō܂ŊmF
            CN = Asc(strSource(i))
            If (CN < &H20) Or (CN > &HDF) Or ((CN > &H7E) And (CN < &HA0)) Then  'R[h̏ꍇ
                CN = Asc(strNew)                                                 'u
            End If
            strResult = strResult & Chr(CN)
        Next i
        Return strResult
    End Function

End Module
